'*******************************************************************************
'Programm for Display ILI9341 240x320 Pixel
'
'Bascom IDE 2.0.7.8
'
'    Version: V12
'    Date:22.05.2014
'    Email: Hkipnik@aol.com
'    Copyright (c) 2013 Hkipnik.  All rights reserved.
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'*******************************************************************************
$nocompile
'*******************************************************************************
' Draw BMP Picture with 24Bit Color
'*******************************************************************************
'*******************************************************************************
' Draw Pic x start -- y start -- Breite -- Hhe from SRAM  Bin file
' before Call Sub you must Restore the Label
'*******************************************************************************
'Sub Lcd_pic_sram(byval Xs As Word , Byval Ys As Word , Byval Breite As Word , Byval Height As Word )
 '
'End Sub
'*******************************************************************************
' Draw Box x start -- y start -- xend -- yend -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
'*******************************************************************************
'Sub Lcd_box(byval Xstart As Word , Byval Ystart As Word , Byval Xend As Word , Byval Yend As Word , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)
'
'End Sub

'*******************************************************************************
' Lcd show BGC File  X Start  Y Start
' Important that you first RESTORE the image before calling this sub
'*******************************************************************************
'Sub Lcd_show_bgc(byval Xoffset As Word , Byval Yoffset As Word)


'End Sub
'*******************************************************************************
' Draw Text String  x y Start - Font Nr - Forecolor - Backcolor - Bold Nr 1 - 2 - 3 -4  1 is normal
' Beta Test
'*******************************************************************************
Sub Lcd_text(byval Lcd_text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word , Byval Bold As Byte)

   Local Pzeichen As String * 1
   Local Zeichen_row As Word
   Local Ptemp As Word
   Local Ptemp2 As Word
   Local Px As Word
   Local Py As Word
   Local Char_rows As Byte
   Local Char_row_len As Byte
   Local Char_bytes As Byte
   Local Dummy As Byte
   Local String_pos As Byte
   Local Zeichen_code As Word
   Local Fcolh As Byte , Fcoll As Byte , Bacolh As Byte , Bacoll As Byte
   Local Doph As Word , Zbv As Byte
   Fcolh = High(forecolor)
   Fcoll = Low(forecolor)
   Bacolh = High(backcolor)
   Bacoll = Low(backcolor)

   '
         Char_rows = Lookup(0 , font8x8)       ' Font12x16
         Char_row_len = Lookup(1 , font8x8)       ' Font12x16
         Char_bytes = Lookup(2 , font8x8)       ' Font12x16
         Dummy = Lookup(3 , font8x8)       ' Font12x16
     '

   For String_pos = 1 To Len(lcd_text)       'Fr jedes Zeichen im String
      Pzeichen = Mid(lcd_text , String_pos , 1)       'Ein Zeichen aus String holen
      Zeichen_code = Asc(pzeichen) - 32       'Font files start with caracter 32
      Zeichen_code = Zeichen_code * Char_bytes

      Doph = Zeichen_code
      Doph = Doph + 4
      For Px = 1 To Char_bytes

         'Select Case Fontset
          '  Case 1 : Zeichenarray(px) = Lookup(doph , Font25x32)
            Zeichenarray(px) = Lookup(doph , font8x8)       ' Font12x16
          '  Case 3 : Zeichenarray(px) = Lookup(doph , Crn20x24)
          '  Case 4 : Zeichenarray(px) = Lookup(doph , Digital20x32)
         'End Select
         Incr Doph

      Next Px

      Py = Char_rows * 8
      Py = Py * Bold
      Py = Py + Lcd_posy

      Px = String_pos - 1
      Px = Px * Char_row_len
      Px = Px + Lcd_posx

      Select Case Bold
         Case 1:
            Ptemp = Px + Char_row_len
         Case 2:
            Px = Px * Bold       '* 2
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 3:
            Px = Px * Bold       '* 3
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
         Case 4:
            Px = Px * Bold       '* 4
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Px = Px - Lcd_posx
            Ptemp = Px + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
            Ptemp = Ptemp + Char_row_len
      End Select

      Decr Ptemp
      Call Lcd_set_window(px , Lcd_posy , Ptemp , Py)
      'Lcd_cs = 0
      Lcd_dc = 1

      For Py = 1 To Char_rows
         Ptemp = Py - 1
         Ptemp = Ptemp * Char_row_len

         For Zeichen_row = 0 To 7
            For Doph = 1 To Bold
               For Px = 1 To Char_row_len
                  Ptemp2 = Ptemp + Px
                  If Zeichenarray(ptemp2).zeichen_row = 1 Then
                     For Zbv = 1 To Bold
                        Spiout Fcolh , 1
                        Spiout Fcoll , 1
                     Next Zbv
                  Else
                     For Zbv = 1 To Bold
                        Spiout Bacolh , 1
                        Spiout Bacoll , 1
                     Next Zbv
                  End If
               Next Px
            Next Doph
         Next Zeichen_row
      Next Py
   Next String_pos
   'Lcd_cs = 1
End Sub
'*******************************************************************************
' draw Circle
'*******************************************************************************
'Sub Lcd_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color As Word)

'End Sub
'-------------------------------------------------------------------------------
'LCD Fill Circle
'-------------------------------------------------------------------------------
'Sub Lcd_fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)

'End Sub

'*******************************************************************************
'Draw Line
'*******************************************************************************

'*******************************************************************************
'Set Pixel
'*******************************************************************************
Sub Lcd_set_pixel(byval X As Word , Byval Y As Word , Byval Color As Word)


   'Lcd_cs = 0
   Lcd_dc = 0
   !LDI  R23, $2a
   !OUT    spdr, R23
   Spi_10:
      !sbis spsr, spif
      !rjmp spi_10

      Lcd_dc = 1

      !ldd R26, Y+4
      !Ldd R27, Y+5
      !LD R10, X+
      !LD R11, X
      !OUT    spdr, R11
   Spi_read0:
      !sbis spsr, spif
      !rjmp spi_read0
      !OUT    spdr, R10
   Spi_read2:
      !sbis spsr, spif
      !rjmp spi_read2
      !OUT    spdr, R11
   Spi_read3:
      !sbis spsr, spif
      !rjmp spi_read3
      !OUT    spdr, R10
   Spi_read4:
      !sbis spsr, spif
      !rjmp spi_read4

      Lcd_dc = 0
      !LDI  R23, $2b
      !OUT    spdr, R23
   Spi_11:
      !sbis spsr, spif
      !rjmp spi_11
      Lcd_dc = 1

      !ldd R26, Y+2
      !Ldd R27, Y+3
      !LD R10, X+
      !LD R11, X
      !OUT    spdr, R11
   Spi_ready7:
      !sbis spsr, spif
      !rjmp spi_ready7
      !OUT    spdr, R10
   Spi_ready8:
      !sbis spsr, spif
      !rjmp spi_ready8
      !OUT    spdr, R11
   Spi_ready9:
      !sbis spsr, spif
      !rjmp spi_ready9
      !OUT    spdr, R10
   Spi_read8:
      !sbis spsr, spif
      !rjmp spi_read8

      Lcd_dc = 0
      !LDI  R23, $2c
      !OUT    spdr, R23
   Spi_12:
      !sbis spsr, spif
      !rjmp spi_12

      Lcd_dc = 1
      !ldd R26, Y+0
      !Ldd R27, Y+1
      !LD R10, X+
      !LD R11, X
      !OUT    spdr, R11
   Spi_13:
      !sbis spsr, spif
      !rjmp spi_13
      !OUT    spdr, R10
   Spi_14:
      !sbis spsr, spif
      !rjmp spi_14
      'Lcd_cs = 1
End Sub

'*******************************************************************************
'  Clear Display
'*******************************************************************************
Sub Lcd_clear(byval Color As Word)

   Lcd_set_window 0 , 0 , X_size , Y_size

   'Lcd_cs = 0
   Lcd_dc = 1

   !LD     XL,     Y+0
   !LD     XH,     Y+1
   !LD     R31,    X+
   !LD     R30,    X

      !ldi  R16, $c8       '76800   200
   Wgloop0:
      !ldi  R17, $C0       '192
   Wloop1:

      !OUT    spdr, R30
   Spi_ready1:
      !sbis spsr, spif
      !rjmp spi_ready1
      !OUT    spdr, R31
   Spi_ready:
      !sbis spsr, spif
      !rjmp spi_ready

      !OUT    spdr, R30
   Spi_ready2:
      !sbis spsr, spif
      !rjmp spi_ready2
      !OUT    spdr, R31
   Spi_ready3:
      !sbis spsr, spif
      !rjmp spi_ready3

      !subi R17, 1
      !brne wloop1

      !subi R16, 1
      !brne wgloop0
     ' Lcd_cs = 1

End Sub

'*******************************************************************************
' Set Window Area to write Data
'*******************************************************************************
Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)

 '  Lcd_cs = 0
   Lcd_dc = 0
   !LDI  R23, $2a
   !OUT    spdr, R23
   Spi_30:
      !sbis spsr, spif
      !rjmp spi_30
      Lcd_dc = 1

      !ldd R26, Y+6       ' xpos
      !Ldd R27, Y+7
      !LD R18, X+
      !LD R17, X

      !OUT    spdr, R17
   Spi_read31:
      !sbis spsr, spif
      !rjmp spi_read31
      !OUT    spdr, R18
   Spi_read32:
      !sbis spsr, spif
      !rjmp spi_read32


      !ldd R26, Y+2       ' xsize
      !Ldd R27, Y+3
      !LD R18, X+
      !LD R17, X
      !OUT    spdr, R17
   Spi_read33:
      !sbis spsr, spif
      !rjmp spi_read33
      !OUT    spdr, R18
   Spi_read34:
      !sbis spsr, spif
      !rjmp spi_read34

      Lcd_dc = 0
      !LDI  R23, $2b
      !OUT    spdr, R23
   Spi_35:
      !sbis spsr, spif
      !rjmp spi_35
      Lcd_dc = 1

      !ldd R26, Y+4       ' ypos
      !Ldd R27, Y+5
      !LD R18, X+
      !LD R17, X
      !OUT    spdr, R17
   Spi_read36:
      !sbis spsr, spif
      !rjmp spi_read36
      !OUT    spdr, R18
   Spi_read37:
      !sbis spsr, spif
      !rjmp spi_read37

      !ldd R26, Y+0       ' ysize
      !Ldd R27, Y+1
      !LD R18, X+
      !LD R17, X
      !OUT    spdr, R17
   Spi_read38:
      !sbis spsr, spif
      !rjmp spi_read38
      !OUT    spdr, R18
   Spi_read39:
      !sbis spsr, spif
      !rjmp spi_read39

      Lcd_dc = 0
      !LDI  R23, $2c
      !OUT    spdr, R23
   Spi_40:
      !sbis spsr, spif
      !rjmp spi_40

    '  Lcd_cs = 1

End Sub

'*******************************************************************************
' Read Touch  X  Y
'*******************************************************************************


'*******************************************************************************
' send Color Data
'*******************************************************************************
Sub Lcd_write_color(byval Color As Word)

   Rgb16 = Color

  ' Lcd_cs = 0
   Lcd_dc = 1
   Spiout Rgb16_high , 1
   Spiout Rgb16_low , 1
 '  Lcd_cs = 1
End Sub
'*******************************************************************************
' send Command
'*******************************************************************************
Sub Lcd_write_command(byval Command As Byte)
  ' Lcd_cs = 0
   Lcd_dc = 0
   Spiout Command , 1
  ' Lcd_cs = 1
End Sub
'*******************************************************************************
'  send Data
'*******************************************************************************
Sub Lcd_write_data(byval Da_ta As Byte)
  ' Lcd_cs = 0
   Lcd_dc = 1
   Spiout Da_ta , 1
  ' Lcd_cs = 1
End Sub
'*******************************************************************************
' Init the display
'*******************************************************************************
Sub Lcd_init()

   Lcd_reset = 0
   Waitms 250
   Lcd_reset = 1
   Waitms 150


   Call Lcd_write_command(&Hcb)       'Power control A
   Call Lcd_write_data(&H39)
   Call Lcd_write_data(&H2c)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H34)
   Call Lcd_write_data(&H02)

   Call Lcd_write_command(&Hcf)       'Power control B
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&Hc1)       '8b
   Call Lcd_write_data(&H30)

   Call Lcd_write_command(&He8)       'Driver timing control A (
   Call Lcd_write_data(&H85)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H78)


   Call Lcd_write_command(&Hea)       'Driver timing control B
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H00)


   Call Lcd_write_command(&Hed)       'Power on sequence control
   Call Lcd_write_data(&H64)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H12)
   Call Lcd_write_data(&H81)

   Call Lcd_write_command(&Hf7)       'Pump ratio control
   Call Lcd_write_data(&H20)

   Call Lcd_write_command(&Hc0)       'Power control
   Call Lcd_write_data(&H23)

   Call Lcd_write_command(&Hc1)       'Power control
   Call Lcd_write_data(&H10)

   Call Lcd_write_command(&Hc5)       'VCM control
   Call Lcd_write_data(&H3e)
   Call Lcd_write_data(&H28)

   Call Lcd_write_command(&Hc7)       'VCOM Control 2
   Call Lcd_write_data(&H86)

   #if Lcd_mode = 1
      Call Lcd_write_command(&H36)       'Memory Access Control
      Call Lcd_write_data(&B0100_1000)       '0100-1000
   #elseif Lcd_mode = 2
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1000_1000)
   #elseif Lcd_mode = 3
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B1110_1000)

   #elseif Lcd_mode = 4
      Call Lcd_write_command(&H36)
      Call Lcd_write_data(&B0010_1000)
   #endif

   Call Lcd_write_command(&H3a)       'COLMOD: Pixel Format Set
   Call Lcd_write_data(&H55)

   Call Lcd_write_command(&Hb1)       'Frame Rate Control (In Normal Mode/Full Colors)
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H18)

   Call Lcd_write_command(&Hb6)       'Display Function Control
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H82)
   Call Lcd_write_data(&H27)

   Call Lcd_write_command(&Hf2)       '3Gamma Function Disable
   Call Lcd_write_data(&H00)

   Call Lcd_write_command(&H26)       'Gamma curve selected
   Call Lcd_write_data(&H01)


   Call Lcd_write_command(&He0)       'Set Gamma
   Call Lcd_write_data(&H0f)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&H2b)
   Call Lcd_write_data(&H0c)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H4e)
   Call Lcd_write_data(&Hf1)
   Call Lcd_write_data(&H37)
   Call Lcd_write_data(&H07)
   Call Lcd_write_data(&H10)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H09)
   Call Lcd_write_data(&H00)

   Call Lcd_write_command(&He1)       'Set Gamma
   Call Lcd_write_data(&H00)
   Call Lcd_write_data(&H0e)
   Call Lcd_write_data(&H14)
   Call Lcd_write_data(&H03)
   Call Lcd_write_data(&H11)
   Call Lcd_write_data(&H07)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&Hc1)
   Call Lcd_write_data(&H48)
   Call Lcd_write_data(&H08)
   Call Lcd_write_data(&H0f)
   Call Lcd_write_data(&H0c)
   Call Lcd_write_data(&H31)
   Call Lcd_write_data(&H36)
   Call Lcd_write_data(&H0f)


   Call Lcd_write_command(&H11)       'Exit Sleep
   Waitms 150
   Call Lcd_write_command(&H29)       'normal display on
   Waitms 150
End Sub