'Bascom IDE 2.0.7.8
'
'****************************************************
'*   Driver for Display ILI9341 SPI 240x320         *
'*       Copyright (c) 2013 Hkipnik.                *
'****************************************************
'*          Programm Hameleon 2.03                  *
'*      ILI9341           *
'****************************************************
'  HAMELEON D2 ILI9341 VERS 001 spi 009.bas
$regfile = "m32def.dat"
$crystal = 16000000       '   
const f_qvarca = 16       '       
$hwstack = 64       '
$swstack = 32       ' 
$framesize = 256       '
'$sim

'*******************************************************************************
Const Sdcard = 0       'SD Card = no
Const Lcd_mode = 4       'LCD Mode 1=Portrait 2=Portrait 180 3=landscape 4=landscape 180
Const Use_touch = 0       'Touch = no
Const Touch_calibrate = 0       'Calibrate Touch  0=no

'*******************************************************************************
'     gjlrk.xtybt lbcgktz
Config Portb.3 = Output       'LCD CS
Config Portb.4 = Output       'LCD D/C
Config Portb.6 = Output       'LCD Reset
Lcd_cs Alias Portb.3
Lcd_dc Alias Portb.4
Lcd_reset Alias Portb.6
Lcd_cs = 0
'*******************************************************************************
' 
$include "ILI9341_declarations_spi.inc"

'*******************************************************************************
' SPI
'*******************************************************************************
Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
'  SPI SPSR
Spsr.spi2x = 1       ' 
 Spiinit
$include "pin_vers_2_03.inc"
'   
 for x = 1 to 320
     osc_clear(x) = 0
   next x

 gosub setband
   '2.03  *

   Lcd_init
   '                                             'INIT Display   time_010.bas
   Lcd_clear Black
   Lcd_text "OSCILLOSCOP" , 30 , 20 , 2 , red , Black , 3
   Lcd_text "ILI9341   240x320" , 20 , 80 , 2 , Yellow , Black , 2
   Lcd_text "   Novice User    " , 20 , 120 , 2 , Blue , Black , 2
   Lcd_text "   VERSION 2.03  " , 20 , 160 , 2 , Blue , Black , 2
   Lcd_text "                 " , 20 , 200 , 2 , Blue , Black , 2
   waitms 1000
   Lcd_clear Black

   gosub lcd_menu
Do
   '
   incr _time
   if _time > 3000 then goto label_off
  ' 9280
  new_read:       '
   if pause = 0 then gosub read_adc       '     9280

   if pause = 0 then gosub        '   
   gosub 
   gosub setka
   color = Yellow
   gosub lcd_sincr
   if pause = 0 then gosub voltmeter
   if pause = 0 then
   if button_left = 0 then       '
       if menu > 0 then decr menu else menu = 4
        _time = 0
       gosub lcd_menu
       while button_left = 0
       wend
       end if
   if button_right = 0 then       ' 
       if menu < 4 then incr menu else menu = 0
        _time = 0

       gosub lcd_menu
       while button_right = 0
       wend
       end if
   if button_down = 0 then       ' 
        _time = 0
        Select Case menu
        Case 0 : if band < 7 then incr band : gosub setband
        Case 1 : if razv > 0 then decr razv
        Case 2 : toggle AC_DC : gosub setband
        Case 3 : color = Black
                 gosub lcd_sincr
                 if Usinc < 240 then incr Usinc
                 Usinc_ERAM = Usinc
        Case 4 : if  < 254 then incr 
                 if AC_DC = 1 then _ERAM = 
                 if AC_DC = 0 then _ERAM_ac = 
                 Pwm1a = 

        End Select
        gosub lcd_menu
          while button_down = 0 and menu < 3
          wend
    end if
   if button_up = 0 then       ' 
        _time = 0
       Select Case menu
        Case 0 : if band > 0 then decr band : gosub setband
        Case 1 : if razv < 10 then incr razv
        Case 2 : toggle AC_DC : gosub setband
        Case 3 : color = Black
                 gosub lcd_sincr
                 if Usinc > 20 then decr Usinc
                 Usinc_ERAM = Usinc
        Case 4 : if  > 20 then decr 
                 if AC_DC = 1 then _ERAM = 
                 if AC_DC = 0 then _ERAM_ac = 
                 Pwm1a = 
        End Select
        gosub lcd_menu
          while button_up = 0 and menu < 3
          wend
    end if
    end if
    if pause = 1 then
           x = t_na_delenie / 2
          'if button_left = 0 and sinhr <= t_na_delenie then sinhr = 0
          if button_left = 0 and sinhr > x then sinhr = sinhr -x       '40
          if button_right = 0 and sinhr < 680 then sinhr = sinhr + x       ' 40
          text = str(sinhr) + "  "
   Lcd_text text , 2 , 231 , 2 , Cyan , Black , 1
          x = sinhr + 320
          text = str(x) + " "
   Lcd_text text , 286 , 231 , 2 , Cyan , Black , 1
    end if

  if button_menu = 0 then
      toggle pause
      color = Black
      gosub lcd_sincr
      Lcd_text "                " , 0 , 223 , 2 , red , Black , 2
      Lcd_text "   " , 288 , 223 , 2 , Cyan , Black , 2


      if pause = 1 then
           Lcd_text "                                        " , 0 , 231 , 2 , red , Black , 1
           Lcd_text "PAUSE" , 103 , 231 , 2 , red , Black , 1
      end if
    x = 0
    while button_menu = 0
      incr x
        if x = 200 then
         label_off:
           Lcd_clear Black
           Lcd_text "OFF" , 100 , 100 , 2 , red , Black , 4
           'powerdown
           waitms 500
           Lcd_clear Black
           band = band * 16
           razv = razv + band
           razv.7 = AC_DC
           pamyat = razv
           Call Lcd_write_command(&H28)
           vcc_on = 0
           wait 100
        end if
      waitms 10


    wend
      end if

   gosub adc_batt
   '  
    if ch_ok = 0 then

     if s <= 4.1 then
       '     
       Lcd_text "CRGE" , 286 , 6 , 2 , red , Black , 1
       _time = 0       ' 
     else
       '  ,  USB
       Lcd_text "100%" , 286 , 6 , 2 , Blue , Black , 1
     ch_on = 0

     end if
    end if
   '   
   if ch_ok = 1 then
   if s < 3.7 then       ' 
           Lcd_text Fusing(s , "#.##") , 286 , 6 , 2 , red , Black , 1
           else
           Lcd_text Fusing(s , "#.##") , 286 , 6 , 2 , Blue , Black , 1
           end if

    end if

Loop
 End

'*********************************
'  
adc_batt:
  ch_on = 1
  x = Getadc(0)
  s = x * adc_opora
  s = s / 497
  'Lcd_text Fusing(s , "#.##") + " V  " , 256 , 226 , 2 , Blue , Black , 1
return

'   
lcd_menu:
COLOR = Cyan
'if menu = 0 then  3*8*2=48
  Select Case band
  Case 0 : text = "20V"
  Case 1 : text = "10V"
  Case 2 : text = "4 V"
  Case 3 : text = "2 V"
  Case 4 : text = "1 V"
  Case 5 : text = "0.4"
  Case 6 : text = "0.2"
  Case 7 : text = "0.1"       '3*16=48
  End Select
 if menu = 0 then COLOR = red else COLOR = Green
 Lcd_text text , 2 , 2 , 1 , COLOR , Blue0 , 2

  'end if
'if menu = 1 then  12345
  Select Case razv
  case 0 : text = "z 5us"       '2.5
  case 1 : text = " 10us"       '5
  case 2 : text = " 20us"       '10
  case 3 : text = " 40us"       '20
  case 4 : text = "100us"       '50
  case 5 : text = "200us"       '0.1       ' 1 =3/15 =0,2 
  case 6 : text = "400us"       ' 0.2
  case 7 : text = " 1 ms"       '  0.5
  case 8 : text = " 2 ms"       ' 1
  case 9 : text = " 4 ms"       ' 2
 case 10 : text = "10 ms"       ' 5     '5*16=80
  End Select
if menu = 1 then COLOR = red else COLOR = Green
 Lcd_text text , 52 , 2 , 1 , COLOR , Blue0 , 2
  'end if
'if menu = 2 then
   IF AC_DC = 0 THEN text = "AC" else text = "DC"
   if menu = 2 then COLOR = red else COLOR = Green
   Lcd_text text , 134 , 2 , 1 , COLOR , Blue0 , 2
'end if
   if menu = 3 then COLOR = red else COLOR = Green
   Lcd_text "SYNC" , 168 , 2 , 1 , COLOR , Blue0 , 2
   if menu = 4 then COLOR = red else COLOR = Green
   Lcd_text ">0<" , 234 , 2 , 1 , COLOR , Blue0 , 2
   if _time => 3000 then text = "      "
   ' Lcd_text text , 0 , 223 , 2 , COLOR , Black , 2

 COLOR = Blue
  for x = 0 to 319       '67
        Lcd_set_pixel x , 0 , COLOR
        Lcd_set_pixel x , 1 , COLOR
        Lcd_set_pixel x , 17 , COLOR
        Lcd_set_pixel x , 18 , COLOR
    next x
  for y = 0 to 17       '67
        Lcd_set_pixel 0 , y , COLOR
        Lcd_set_pixel 1 , y , COLOR
        Lcd_set_pixel 50 , y , COLOR
        Lcd_set_pixel 51 , y , COLOR
        Lcd_set_pixel 132 , y , COLOR
        Lcd_set_pixel 133 , y , COLOR
        Lcd_set_pixel 166 , y , COLOR
        Lcd_set_pixel 167 , y , COLOR
        Lcd_set_pixel 232 , y , COLOR
        Lcd_set_pixel 233 , y , COLOR
        Lcd_set_pixel 283 , y , COLOR
        Lcd_set_pixel 284 , y , COLOR
        Lcd_set_pixel 318 , y , COLOR
        Lcd_set_pixel 319 , y , COLOR
    next y

return

setka:
   COLOR = Blue       ' 
   Lcd_text "0" , 2 , 225 , 1 , COLOR , Black , 1
   z = u_na_delenie
   Lcd_text "1" , 2 , 225 -z , 1 , COLOR , Black , 1
   z = 2 * u_na_delenie
   Lcd_text "2" , 2 , 225 -z , 1 , COLOR , Black , 1
   z = 3 * u_na_delenie
   Lcd_text "3" , 2 , 225 -z , 1 , COLOR , Black , 1
   z = 4 * u_na_delenie
   Lcd_text "4" , 2 , 225 -z , 1 , COLOR , Black , 1
   z = 5 * u_na_delenie
   if z < 206 then Lcd_text "5" , 2 , 225 -z , 1 , COLOR , Black , 1
   z = 6 * u_na_delenie
   if z < 206 then Lcd_text "6" , 2 , 225 -z , 1 , COLOR , Black , 1
   COLOR = Green1
   '
   for x = 10 to 310 step t_na_delenie       '50       '45 for 27 mz
        for y = 20 to 239 step 4       ' 20-239
        Lcd_set_pixel x , y , COLOR
        next y
   next x
   '
   'z=
   for x = 0 to 319 step 4
        'for y = 228 to 24 step u_na_delenie       '28,68,108,148,188,228
        Lcd_set_pixel x , 228 , COLOR
        z = u_na_delenie
        Lcd_set_pixel x , 228 -z , COLOR
        z = 2 * u_na_delenie
        Lcd_set_pixel x , 228 -z , COLOR
        z = 3 * u_na_delenie
        Lcd_set_pixel x , 228 -z , COLOR
        z = 4 * u_na_delenie
        Lcd_set_pixel x , 228 -z , COLOR
        z = 5 * u_na_delenie
        if z < 206 then Lcd_set_pixel x , 228 -z , COLOR

        z = 6 * u_na_delenie
        if z < 206 then Lcd_set_pixel x , 228 -z , COLOR


        'next y
   next x
RETURN


:
  'gosub read4
   y = 0

  '      
 for x = 1 to 1024
     if osc(x) > 219 then osc(x) = 219
     osc(x) = osc(x) + 20
  next x
  sinhr = 1       '+ sdvig
  for x = 11 to 700
   if osc(x -1) => Usinc and osc(x) => Usinc and osc(x + 1) <= Usinc and osc(x + 2) <= Usinc then
      if sinhr = 1 then sinhr = x       '       
      goto label1
      end if
   next x
label1:
 z = 0
 s = 1
 for x = sinhr to 1020
      if osc(x) => Usinc and osc(x + 1) <= Usinc then
         'Lcd_set_pixel x , Usinc , color       'Black
         incr z       '                         
         s = x       '                         
         x = x + 2
      end if
 next x
   if z > 200 and razv > 0 then
        decr razv
        gosub lcd_menu
        goto new_read
        end if
   if z > 2 then
     decr z
     s = s - sinhr
     s = s / z
     Select Case razv
       case 0 : s = s * 5       ' "z 5us"       '2.5
       case 1 : s = s * 10       ' " 10us"       '5
       case 2 : s = s * 20       ' " 20us"       '10
       case 3 : s = s * 40       '" 40us"       '20
       case 4 : s = s * 100       ' "100us"       '50
       case 5 : s = s * 200       ' "200us"       '0.1       ' 1 =3/15 =0,2 
       case 6 : s = s * 400       '"400us"       ' 0.2
       case 7 : s = s * 1000       ' " 1 ms"       '  0.5
       case 8 : s = s * 2000       ' " 2 ms"       ' 1
       case 9 : s = s * 4000       '" 4 ms"       ' 2
       case 10 : s = s * 10000       ' "10 ms"       ' 5     '5*16=80
     End Select
     s = s / t_na_delenie       '=1/
     'text = "T=" + fusing(s , "###.#") + "usec "
   ' Lcd_text text , 203 , 211 , 2 , Green , Black , 1
     s = 1000 / s
     if s < 10 then text = fusing(s , "&.&&")
     if s => 10 and s < 100 then text = fusing(s , "&&.&")
     if s => 100 then text = fusing(s , "&&&.")
     text = "F=" + text + "KHZ"
     Lcd_text text , 243 , 231 , 2 , Green , Black , 1
     text = " "
 else
     text = "F=____KHZ"
     Lcd_text text , 243 , 231 , 2 , Green , Black , 1
 END IF
return
'  
lcd_sincr:
         ' color = Yellow
          for x = 10 to 319 step 8
              Lcd_set_pixel x , Usinc , color       'Black
            next x
return

voltmeter:
  u_min = 0
  u_max = 255
 for x = 1 to 1024
   if osc(x) < u_max then u_max = osc(x)
   if osc(x) > u_min then u_min = osc(x)
next x
 u_max = 255 -u_max : u_min = 255 -u_min
 if u_min > 26 then znak = " " else znak = "-"
 if u_min < 27 then u_min = 27 -u_min else u_min = u_min -27
 if u_max < 27 then u_max = 27 -u_max else u_max = u_max -27
 if znak = " " then u_ptp = u_max - u_min else u_ptp = u_max + u_min       'u_sr = u_sr + x
  if band = 0 then koeff = u_na_delenie / 20       '20
  if band = 1 then koeff = u_na_delenie / 10       '10
  if band = 2 then koeff = u_na_delenie / 4       '4
  if band = 3 then koeff = u_na_delenie / 2       '2
  if band = 4 then koeff = u_na_delenie * 1       '1
  if band = 5 then koeff = u_na_delenie * 2.5
  if band = 6 then koeff = u_na_delenie * 5
  if band = 7 then koeff = u_na_delenie * 10       '3*16=48
 's = 0.023
 s = u_max
 s = s / koeff
 text = "Umax=" + fusing(s , "#.#") + "V "       '  str() + "    "
 Lcd_text text , 3 , 231 , 2 , Green , Black , 1
 s = u_min
 s = s / koeff
 if znak = " " then text = "Umin=" + fusing(s , "#.#") + "V " else text = "Umn=-" + fusing(s , "#.#") + "V "
 Lcd_text text , 83 , 231 , 2 , Green , Black , 1
 s = u_ptp
 s = s / koeff
 text = "Uptp=" + fusing(s , "#.#") + "V "
 Lcd_text text , 163 , 231 , 2 , Green , Black , 1
 text = ""
return


:

   for y = 20 to 239
     Lcd_set_pixel 318 , y , Black
  '    Lcd_set_pixel 319 , y , Black
   next y
   ' , -    
  '  
   for x = 10 to 318       'x_max       '320
       w = x - 1       '   
       if osc_clear(x) < osc_clear(x + 1) then
           for y = osc_clear(x) to osc_clear(x + 1)
              Lcd_set_pixel w , y , Black
            next y
        else
            for y = osc_clear(x + 1) to osc_clear(x )
              Lcd_set_pixel w , y , Black
            next y
       end if
   '   
      a = x + sinhr
      if sinhr > 10 then a = a - 10
      if a < 1025 then
        if osc(a ) < osc(a + 1 ) then
            for y = osc(a) to osc(a + 1)
               Lcd_set_pixel w , y , red
            next y
        else
            for y = osc(a + 1) to osc(a )
              Lcd_set_pixel w , y , red
            next y
        end if
       end if

   next x
   for x = 1 to x_max
       a = x + sinhr
       if sinhr > 10 then a = a - 10
       osc_clear(x) = osc(a)
   next x
 COLOR = Blue
   for x = 0 to 319       '67
        Lcd_set_pixel x , 239 , COLOR
     next x
  for y = 18 to 239       '67
        Lcd_set_pixel 0 , y , COLOR
        Lcd_set_pixel 319 , y , COLOR
    next y
return
' 
setband:
  porta.5 = band.0
  porta.6 = band.1
  porta.7 = band.2
  Portb.0 = AC_DC
  if AC_DC = 1 then  = _ERAM
  if AC_DC = 0 then  = _ERAM_ac
  Pwm1a = 
 return
 '*******************************************************************************
$include "ILI9341_routines.inc"       ' _sp_32p_02_01
' 
$include "Font\font8x8.font"
'$include "Font\Digital11x16.font"
$include "ADCREAD_vers_2.inc"